from flask import Flask
from flask_cors import CORS

from sqlalchemy.engine.url import make_url
from werkzeug.contrib.fixers import ProxyFix

from app.extensions import api
from app.extensions import db, migrate
from app.api.hotel_api import hotels
from app.api.city_api import cities

from config import config

#NAMESPACES = [
#    hotels,
#    cities
#]

def create_api(environment_name=None):
    app = Flask(__name__)

    app.config.from_object(config[environment_name])
    # app.wsgi_app = ProxyFix(app.wsgi_app)

    CORS(app)

#    for namespace in NAMESPACES:
#        api.add_namespace(namespace)

    with app.app_context():

        db.init_app(app)
        migrate.init_app(app, db)
#        db.apply_driver_hacks(app=app,
#                              info=make_url(app.config.get('SQLALCHEMY_DATABASE_URI')),
#                              options=dict(isolation_level='AUTOCOMMIT'))

    api.init_app(app)
    return app

